/*
*/
#ifndef __GLOBALS_H
#define __GLOBALS_H

//#define DEBUG

#include <avr/io.h>

#define VERSION_MAJOR 1
#define VERSION_MINOR 3


#define SENSE_bp 2
#define SENSE_bm (1<<SENSE_bp)

typedef enum {
	FUNCTION_ERROR			= 0,
	FUNCTION_SWEEP,
	FUNCTION_DISPLAY,
	FUNCTION_METER,
	FUNCTION_THERMOMETER,
	FUNCTION_POV,
	FUNCTION_ROULETTE,

	FUNCTION_MENU_MAIN,
	FUNCTION_MENU_FUNCTION,
	FUNCTION_MENU_SWEEPER,
	FUNCTION_MENU_METER,
	FUNCTION_MENU_CHAIN,
	FUNCTION_MENU_CHAIN_LENGTH,
	FUNCTION_MENU_CHAIN_POS,
	FUNCTION_MENU_UTILS,
	FUNCTION_MENU_TICK,
	FUNCTION_MENU_TRANSMIT,

	FUNCTION_SET_FUNCTION,
	FUNCTION_SET_METER,
	FUNCTION_SET_CHAIN_LENGTH,
	FUNCTION_SET_CHAIN_POS,
	FUNCTION_IMPORT,
	FUNCTION_SET_TICK,
	FUNCTION_SET_TRANSMIT,
	FUNCTION_VERSION,

	FUNCTION_MARKER_END
} FunctionID_t ;

typedef enum {
	RANGE_RESET,
	RANGE_SETMIN,
	RANGE_SETMAX
} Range_Action_t ;

typedef enum {
	IMPORT_USER_PATTERN
} Import_Action_t ;

#define TICK_VERYSLOW	200
#define TICK_SLOW			80
#define TICK_MEDIUM		40
#define TICK_FAST			20
#define TICK_VERYFAST	10

typedef enum {
	TRANSMIT_DISABLE	= 0,
	TRANSMIT_ENABLE		= 1
} Transmit_t ;

typedef enum {
	CMD_ClearAll		= 0,
	CMD_SetAll			= 1,
	CMD_SetLED			= 2,
	CMD_ClearLED		= 3,
	CMD_SetBinary		= 4,
	CMD_Style				= 8,
	CMD_UserPattern	= 9,
	CMD_NULL				= 31 // maximum possible command ID
} CommandID_t ;

#define STYLE_COUNT 4
typedef enum {
	STYLE_Exponential	= 0,
	STYLE_Direct			= 1,
	STYLE_Sparkle			= 2,
	STYLE_Drift				= 3
} StyleID_t ;

typedef void function_handler( uint8_t data ) ;

extern uint8_t g_function_id ;
extern uint8_t g_function_data ;
extern uint8_t g_chain_length ; // 1 to 4
extern uint8_t g_chain_pos ; // 1 to g_chain_length
extern uint8_t g_myfirstled ; // 0,8,16 or 24
extern uint8_t g_chain_ledlength ; // 8,16,24 or 32
extern uint16_t g_meter_min  ; // 0 to 1023, from a 10 bit ADC result.
extern uint16_t g_meter_max  ; // 0 to 1023, from a 10 bit ADC result.
extern uint8_t g_tickdelay ; // duration of a 'tick' in 10ths of a ms (e.g. 10 = 1ms)
extern uint8_t g_transmit ; // non-zero if data can be transmitted?

void eeprom_restore_state( void ) ;
void eeprom_save_state( void ) ;

// The following functions return a pointer to eeprom locations.
//uint8_t *eeprom_get_povbitmap( void ) ;
uint8_t *eeprom_get_sweepuserpattern( void ) ;

#endif
