#ifndef __SERIAL_H
#define __SERIAL_H

#include <avr/io.h>

void serial_init( void ) ;
void serial_autobaud( void ) ;
uint8_t serial_getbyte( uint8_t *status ) ;
void serial_finish( void ) ;

void __attribute__((noreturn)) serial_eeprom_load( uint8_t *e, uint16_t datalength, uint16_t streamoffset ) ;


// bit positions in status byte:
// 0	OK
// 1	BREAK (line was idle before byte receieved - this is the first byte)
// 2
// 3
// 4
// 5
// 6	ERROR_PARITY (parity bit didn't match the data)
// 7	ERROR_FRAME (invalid stop bit found)
#define SERIAL_OK_bp 0
#define SERIAL_BREAK_bp 1
#define SERIAL_ERROR_PARITY_bp 6
#define SERIAL_ERROR_FRAME_bp 7
#define SERIAL_OK_bm (1<<SERIAL_OK_bp)
#define SERIAL_BREAK_bm (1<<SERIAL_BREAK_bp)
#define SERIAL_ERROR_PARITY_bm (1<<SERIAL_ERROR_PARITY_bp)
#define SERIAL_ERROR_FRAME_bm (1<<SERIAL_ERROR_FRAME_bp)

#endif
